@ECHO OFF

CALL :DoVacuumToInactiveDB
IF NOT %RETVAL%==0 GOTO :EXIT

ECHO Switch ActiveIndex... 1>&2
ECHO Switch ActiveIndex...
activeindex.exe -s active_index=%INACTIVE_INDEX%
SET RETVAL=%ERRORLEVEL%
ECHO Switch ActiveIndex return : %RETVAL%
IF NOT %RETVAL%==0 GOTO :EXIT

CALL :DoVacuumToInactiveDB
IF NOT %RETVAL%==0 GOTO :EXIT

ECHO Switch ActiveIndex... 1>&2
ECHO Switch ActiveIndex...
activeindex.exe -s active_index=%INACTIVE_INDEX%
SET RETVAL=%ERRORLEVEL%
ECHO Switch ActiveIndex return : %RETVAL%
IF NOT %RETVAL%==0 GOTO :EXIT

ECHO Everything is OK... 1>&2
ECHO Everything is OK...
EXIT /B

:DoVacuumToInactiveDB
	:: Try to get active index
	ECHO Getting ActiveIndex... 1>&2
	ECHO Getting ActiveIndex...
	activeindex.exe -g active_index -u
	SET RETVAL=%ERRORLEVEL%
	ECHO Get ActiveIndex return : %RETVAL%
	IF NOT %RETVAL%==0 GOTO:EOF

	:: Get active index
	FOR /f %%i IN ('activeindex.exe -g active_index --showc -u') DO SET ACTIVE_INDEX=%%i 
	IF %ACTIVE_INDEX%==1 (
		SET INACTIVE_INDEX=2
	) ELSE (
		SET INACTIVE_INDEX=1
	)

	ECHO Active index : %ACTIVE_INDEX%, Inactive index : %INACTIVE_INDEX%
	ECHO Active index : %ACTIVE_INDEX%, Inactive index : %INACTIVE_INDEX% 1>&2

	:: Reset Vacuum done
	ECHO Reset Vacuum done... 1>&2
	ECHO Reset Vacuum done...
	attributetool.exe -s db:vacuum:done=0
	SET RETVAL=%ERRORLEVEL%
	ECHO Reset Vacuum done return : %RETVAL%
	IF NOT %RETVAL%==0 GOTO:EOF

	:: Reset Vacuum last index
	ECHO Set Vacuum last index to %ACTIVE_INDEX%... 1>&2
	ECHO Set Vacuum last index to %ACTIVE_INDEX%...
	attributetool.exe -s db:vacuum:last_db_index=%ACTIVE_INDEX%
	SET RETVAL=%ERRORLEVEL%
	ECHO Set Vacuum last index return : %RETVAL%
	IF NOT %RETVAL%==0 GOTO:EOF

	:: Do Vacuum!
	ECHO Do vacuum to db%INACTIVE_INDEX%... 1>&2
	ECHO Do vacuum to db%INACTIVE_INDEX%...
	importmanager.exe -v -l --showlog
	SET RETVAL=%ERRORLEVEL%
	ECHO Do vacuum to db return : %RETVAL%
	IF NOT %RETVAL%==0 GOTO:EOF
	
	:: finish
	GOTO:EOF

:EXIT
	ECHO Some error... %RETVAL% 1>&2
	ECHO Some error...
	EXIT /B
